/******************************************************************************/
/* exemple2.c                        20/03/96 - Edouard.Thiel@lim.univ-mrs.fr */
/*                                                                            */
/* 2. PARAMETRES                                                              */
/******************************************************************************/

/* 
 * Le include suivant est OBLIGATOIRE dans tous vos .c 
*/ 
#include "../IpsDir/include/tel_oper.h"


/*
 * Fonction ex2_seuil appelee par l'operateur ExSeuil
 *
 * Effet : met a 0 les points inferieurs au seuil, a 255 sinon.
 *
*/
void ex2_seuil (ima1, ima2, xsiz, ysiz, seuil)
Unt16 *ima1, *ima2;
int xsiz, ysiz, seuil;
{
    int x, y;

    for (y = 0; y < ysiz; y++)
    for (x = 0; x < xsiz; x++) {
	int t = y*xsiz+x;
	ima2[t] = (ima1[t] < seuil) ? 0 : 255;
    }
}


/*
 * Fonction ex2_shift appelee par l'operateur ExShift
 *
 * Effet : decale l'image de dx,dy (positifs), en completant a 0.
 *
 * Exercice : autoriser un decalage negatif.
*/
void ex2_shift (ima1, ima2, xsiz, ysiz, dx, dy)
Unt16 *ima1, *ima2;
int xsiz, ysiz, dx, dy;
{
    int x, y, dt = dy*xsiz+dx;

    for (y = 0; y < ysiz; y++)
    for (x = 0; x < xsiz; x++) {
	int t = y*xsiz+x;
	ima2[t] = (x < dx || y < dy) ? 0 : ima1[t-dt];
    }
}


/*
 * Fonction ex2_affine appelee par l'operateur ExAffine
 *
 * Effet : transformation affine p2 = p1 * MUL + ADD.
 *
*/
void ex2_affine (ima1, ima2, xsiz, ysiz, fois, plus)
Unt16 *ima1, *ima2;
int xsiz, ysiz;
double fois;
int plus;
{
    int x, y;

    for (y = 0; y < ysiz; y++)
    for (x = 0; x < xsiz; x++) {
	int t = y*xsiz+x;
	int s = (int) ( (double) ima1[t] * fois ) + plus;
	ima2[t] = (s < 0) ? 0 : (s > 255) ? 255 : s;
    }
}

