/******************************************************************************/
/* exemple4.c                        20/03/96 - Edouard.Thiel@lim.univ-mrs.fr */
/*                                                                            */
/* 4. TAILLE DES IMAGES                                                       */
/******************************************************************************/

/* 
 * Le include suivant est OBLIGATOIRE dans tous vos .c 
*/ 
#include "../IpsDir/include/tel_oper.h"


/*
 * Fonction ex4_transpose appelee par l'operateur ExTranspo
 *
 * Effet : transpose l'image en entree. Les tailles sont echangees.
 *
*/
void ex4_transpose (ima1, ima2, xm, ym)
Unt16 *ima1, *ima2;
int xm, ym;
{
    int x, y;

    for (y = 0; y < ym; y++)
    for (x = 0; x < xm; x++)
	ima2[x*ym+y] = ima1[y*xm+x];
}


/*
 * Fonction ex4_superpose appelee par l'operateur ExSuperPos
 *
 * Effet : superpose ima1 sur ima2 avec transparence.
 * tranpar = valeur de transparence, -1 sinon.
 *
*/
void ex4_superpose (ima1, ima2, xm1, ym1, xm2, ym2, dx, dy, transpar)
Unt16 *ima1, *ima2;
int xm1, ym1, xm2, ym2, dx, dy, transpar;
{
    int x, y, t1, t2,
	xa = (dx < 0) ? 0 : dx,			/* calcul des intersections */
	ya = (dy < 0) ? 0 : dy,			/* des images */
	xb = (dx + xm1 > xm2) ? xm2 : dx + xm1,
	yb = (dy + ym1 > ym2) ? ym2 : dy + ym1;

    if (xa < xb && ya < yb)
    for (y = ya; y < yb; y++)
    for (x = xa; x < xb; x++) {
	t2 = y * xm2 + x;
	t1 = (y-dy) * xm1 + x-dx;
	ima2[t2] = (ima1[t1] == transpar) ? ima2[t2] : ima1[t1];
    }
}


