/***************************************************************************************/
/* tel_oper.h                                                 I.P.S  v 3.7  11/03/1996 */
/*                                                                                     */
/* module d'appel des operateurs                         Edouard.Thiel@lim.univ-mrs.fr */
/***************************************************************************************/

#ifndef _IPS_TEL_OPER_H_
#define _IPS_TEL_OPER_H_


#include "attributs.h"

#include <stdio.h>
#include <stdlib.h>
#include <math.h>


/*
 * valeur = CO_GET_ (numero_parametre);
*/

#define  CO_GET_REAL(n)		(*((double *) p->param_adr[n]))
#define  CO_GET_TEXT(n)		((char *) p->param_adr[n])
#define  CO_GET_INT(n)		((int) p->param_adr[n])
#define  CO_GET_CHOICE(n)	CO_GET_INT(n)
#define  CO_GET_CH_ABR(n)	CO_GET_INT(n)
#define  CO_GET_SLIDER(n)	CO_GET_INT(n)
#define  CO_GET_CHK_BOX(n)	CO_GET_INT(n)

/*
 * CO_SET_ (numero_parametre, nouvelle_valeur);
*/

#define  CO_SET_ACTIVE(n,v)	p->inactif[n] = ((v) ? 2 : 1)
#define  CO_SET_REAL(n,v)	*((double *) p->param_adr[p->par_set[n]=(n)]) = (v)
#define  CO_SET_TEXT(n,v)	strcpy ((char *) p->param_adr[p->par_set[n]=(n)], (v))
#define  CO_SET_INT(n,v)	(int) p->param_adr[p->par_set[n]=(n)] = (v)
#define  CO_SET_CHK_BOX(n,v)	CO_SET_INT(n,v)
#define  CO_SET_SLIDER(n,v)	CO_SET_INT(n,v)
#define  CO_SET_CH_ABR(n,v)	CO_SET_INT(n,v)
#define  CO_SET_CHOICE(n,v)	CO_SET_INT(n,v)

/*
 * CO_SET_NAME (numero_image, nouvelle_valeur);
*/

#define  CO_SET_NAME(n,v)	strncpy (p->ima_name[n], v, IMAGE_CH1LEN)

/*
 * CO_SET_ (numero_image);
*/

#define  CO_SET_16C(n)		p->ima_lut[n] = (IPS_COUL_16C+IPS_COUL)
#define  CO_SET_64G(n)		p->ima_lut[n] = (IPS_COUL_64G+IPS_COUL)
#define  CO_SET_BWC(n)		p->ima_lut[n] = (IPS_COUL_BWC+IPS_COUL)

/*
 * CO_SPY_INT (int *adr_valeur, int val_debut, int val_fin);
*/
#define	 CO_SPY_INT(a,d,f)	tp_spy_start (a, d, f)


/*
 * Dessins dans section FIG
*/
#define  CO_DRAW_COLOR(color)		tp_fig_draw (FIG_COLOR,1,color)
#define  CO_DRAW_MODE_CPY		tp_fig_draw (FIG_MODE,1,FIG_CPY)
#define  CO_DRAW_MODE_XOR		tp_fig_draw (FIG_MODE,1,FIG_XOR)
/* 
 * Ces dessins dependent de color et mode :
*/
#define  CO_DRAW_POINT(n,x,y)		tp_fig_draw (FIG_DRAW_POINT,n, \
					(double) x,(double) y)
#define  CO_DRAW_LINE(n,x1,y1,x2,y2)	tp_fig_draw (FIG_DRAW_LINE,n,(double) x1, \
					(double) y1,(double) x2,(double) y2)
#define  CO_DRAW_RECT(n,x1,y1,x2,y2)	tp_fig_draw (FIG_DRAW_RECT,n,(double) x1, \
					(double) y1,(double) x2,(double) y2)
#define  CO_FILL_RECT(n,x1,y1,x2,y2)	tp_fig_draw (FIG_FILL_RECT,n,(double) x1, \
					(double) y1,(double) x2,(double) y2)
#define  CO_DRAW_CIRC(n,xc,yc,rayon)	tp_fig_draw (FIG_DRAW_CIRC,n,(double) xc, \
					(double) yc,(double) rayon)
#define  CO_DRAW_ELLIP(n,x1,y1,x2,y2)	tp_fig_draw (FIG_DRAW_ELLIP,n,(double) x1, \
					(double) y1,(double) x2,(double) y2)
#define  CO_DRAW_ARC(n,x1,y1,x2,y2,a,b)	tp_fig_draw (FIG_DRAW_ARC,n,(double) x1, \
					(double) y1,(double) x2,(double) y2, \
					(int) a,(int) b)
#define  CO_FILL_ARC(n,x1,y1,x2,y2,a,b)	tp_fig_draw (FIG_FILL_ARC,n,(double) x1, \
					(double) y1,(double) x2,(double) y2, \
					(int) a,(int) b)
#define  CO_DRAW_TRIANG(n,x1,y1,x2,y2,x3,y3)	tp_fig_draw (FIG_DRAW_TRIANG,n, \
					(double) x1,(double) y1,(double) x2, \
					(double) y2,(double) x3,(double) y3)
#define  CO_FILL_TRIANG(n,x1,y1,x2,y2,x3,y3)	tp_fig_draw (FIG_FILL_TRIANG,n, \
					(double) x1,(double) y1,(double) x2, \
					(double) y2,(double) x3,(double) y3)
#define  CO_DRAW_CROSS(n,x,y)		tp_fig_draw (FIG_DRAW_CROSS,n,(double) x, \
					(double) y)
#define  CO_DRAW_CURSOR(n,x,y)		tp_fig_draw (FIG_DRAW_CURSOR,n,(double) x, \
					(double) y)
/* 
 * Ces dessins ne dependent pas de color ni de mode : 
*/	
#define  CO_DRAW_MARK(n,x,y)		tp_fig_draw (FIG_DRAW_MARK,n,(double) x, \
					(double) y)
#define  CO_DRAW_LABEL(n,x,y,label)	tp_fig_draw (FIG_DRAW_LABEL,n,(double) x, \
					(double) y,(int) label)
#define  CO_DRAW_VALUE(n,x,y,label)	tp_fig_draw (FIG_DRAW_VALUE,n,(double) x, \
					(double) y,(int) label)
/* 
 * Ces commandes provoquent un refresh de l'image puis un evenement FIG_REFRESH : 
*/
#define  CO_FIG_REFRESH(n)		tp_fig_draw (FIG_CLEAN,n)
#define  CO_FIG_CENTER(n,x,y)		tp_fig_draw (FIG_CENTER,n,(double) x, \
					(double) y)
/* 
 * Cette commande provoque un Run apres la fin de la section FIG :
*/
#define  CO_FIG_DO_RUN			tp_fig_draw (FIG_DO_RUN,1)


/*
 * Les types et constantes
*/

#ifndef VRAI
#define VRAI 1
#endif
#ifndef FAUX
#define FAUX 0
#endif
#ifndef NULL
#define NULL 0
#endif
#ifndef TRUE
#define TRUE 1
#endif
#ifndef FALSE
#define FALSE 0
#endif
#ifndef min
#define min(x,y)	(((x)<(y))?(x):(y))
#endif
#ifndef max
#define max(x,y)	(((x)>(y))?(x):(y))
#endif

/* Categories d'entiers */
 
typedef          char	Int8;
typedef unsigned char	Unt8;
typedef          short	Int16;
typedef unsigned short	Unt16;
typedef          long	Int32;
typedef unsigned long	Unt32;

#define IMAGE_CH1LEN	63
typedef char Image_name[IMAGE_CH1LEN+1];

/* Nombre max de parametres et de donnee's */
#define OPER_VECM	32


typedef struct {
	Unt16		*pix	  [OPER_VECM];	/* adr pixmap 				*/

	Image_name	ima_name  [OPER_VECM];	/* noms images 				*/
	int		ima_lut	  [OPER_VECM],	/* numeros LUT				*/
			ima_x	  [OPER_VECM],
			ima_y	  [OPER_VECM],	/* dimensions images			*/
			ima_n,			/* nb total images			*/
			ima_cmin,		/* val cadre				*/

			chce_num, chce_val,	/* num param et val pour IPS_ACT_CHOICE	*/
			chce_ini,		/* booleen : VRAI quand creation parbox	*/
						/*	ou <default> ou <cancel>	*/

			param_type[OPER_VECM],	/* types des parametres			*/
			inactif   [OPER_VECM],	/* param grise' ou pas			*/
			par_set   [OPER_VECM];	/* valeur param change' avec CO_SET_	*/
	void		*param_adr[OPER_VECM];  /* adresses de stockage des parametres  */

						/* infos sur image 1			*/
	int		cmin,			/* valeur du cadre ; k = cmin .. kmax	*/
			xsiz, xmax, xtot,	/* kmax  = cmin + ksiz	   (k = x ou y)	*/
			ysiz, ymax, ytot,	/* ktot  = cmin + ksiz + cmin		*/
			xytot;			/* xytot = xtot * ytot			*/

	int		fig_num,		/* num figure : 1, ..			*/
			fig_event,		/* FIG_NONE, _DRAG, _REFRESH, ..	*/
			fig_butt,		/* num bouton : 1 ou 2			*/
			fig_zoom;		/* valeur du zoom			*/
	double		fig_x, fig_y;		/* coords re'elles du clic courant	*/
	} Tel_oper_p;


/*
 * Declarations des blocs BEGIN / END
*/

#define  CO_BEGIN_CALL_OPER						\
									\
	int          tel_oper (__action, __idf , p )			\
	int          __action;						\
	char        *__idf;						\
	Tel_oper_p  *p;							\
	{								\
	    int __retour = IPS_ACT_OK;	
								

#define  CO_END_CALL_OPER						\
									\
	    {   switch (__action) {					\
		    case IPS_ACT_DEF : tp_encode_def (IPS_NAME2,	\
			"WARNING no DEF of ",__idf,0); break;		\
		    case IPS_ACT_EXE : break;				\
		} __retour = IPS_ACT_Nidf;				\
	    }   return __retour;					\
	}


#define  CO_BEGIN_CONNECT(x)						\
									\
	if (!strcmp(x, __idf)) switch (__action) {


#define  CO_END_CONNECT							\
									\
	    default : __retour = IPS_ACT_Naction;			\
	} else

#define  CO_BEGIN_DEF							\
									\
	case IPS_ACT_DEF : { tp_encode_def (

#define  CO_END_DEF		0); } break;

#define  CO_BEGIN_DIM		case IPS_ACT_DIM : {
#define  CO_END_DIM		} break;


#define  CO_BEGIN_CHOICE	case IPS_ACT_CHOICE : {
#define  CO_END_CHOICE		} break;


#define  CO_BEGIN_FIG		case IPS_ACT_FIG : {
#define  CO_END_FIG		} break;


#define  CO_BEGIN_EXE		case IPS_ACT_EXE : {
#define  CO_END_EXE		} break;


#endif /* _IPS_TEL_OPER_H_ */

