/***************************************************************************************/
/* globa.c                                                    I.P.S  v 3.1  18/11/1993 */
/*                                                                                     */
/* declaration des variables globales                    Edouard.Thiel@lim.univ-mrs.fr */
/***************************************************************************************/


/* fichiers inclus */

#include "inclus.h"


/* Variables globales */

Glo 	 glo;
Cms 	 cms_palette;   /* vol.7 p.414 */
Unt32 	 coul_16c[256], coul_64g[256], coul_bwc[256], *coul_pic;
Unt8     colR_16c[256], colG_16c[256], colB_16c[256], 
         colR_64g[256], colG_64g[256], colB_64g[256], 
         colR_bwc[256], colG_bwc[256], colB_bwc[256];


static Xv_singlecolor cms_colors[81] =  /* vol.1 p.185 */
{

  /*  {   0,   0,   0 },   *  0 : noir          */
  /*  {  35,  15, 230 },   *  1 : bleu fonce    */
  /*  {  40, 200,  40 },   *  2 : vert          */
  /*  {   0, 255, 255 },   *  3 : cyan          */
  /*  {  30, 155,   0 },   *  4 : vert fonce    */
  /*  { 159,  95, 159 },   *  5 : violet        */
  /*  { 210, 150,  60 },   *  6 : marron        */
  /*  { 210, 210, 210 },   *  7 : gris          */
  /*  { 130, 130, 150 },   *  8 : anthracite    */
  /*  {  64, 150, 255 },   *  9 : bleu tergal   */
  /*  { 180, 255, 150 },   * 10 : vert pastel   */
  /*  { 100, 200, 250 },   * 11 : bleu electric */
  /*  { 240, 120, 120 },   * 12 : rouge         */
  /*  { 255,   0, 255 },   * 13 : magenta       */
  /*  { 255, 255,   0 },   * 14 : jaune         */
  /*  { 255, 255, 255 },   * 15 : blanc         */

    {   0,   0,   0 },   /*  0 : black         */
    {  20,  20, 190 },   /*  1 : blue          */
    {  30, 200,  30 },   /*  2 : green         */
    {  30, 200, 200 },   /*  3 : cyan          */
    { 200,  30,  30 },   /*  4 : red           */
    { 200,  30, 200 },   /*  5 : magenta       */
    { 200, 130,  50 },   /*  6 : brown         */
    { 200, 200, 200 },   /*  7 : light gray    */
    { 110, 110, 140 },   /*  8 : dark gray     */
    {  84, 130, 252 },   /*  9 : light blue    */
    {  84, 252,  84 },   /* 10 : light green   */
    {  84, 252, 252 },   /* 11 : light cyan    */
    { 252,  84,  84 },   /* 12 : light red     */
    { 252,  84, 252 },   /* 13 : light magenta */
    { 252, 252,  84 },   /* 14 : yellow        */
    { 252, 252, 252 },   /* 15 : white         */

    {   0,   0,   0 },   /* 64 niveaux de gris */
    {   4,   4,   4 },
    {   8,   8,   8 },
    {  12,  12,  12 },
    {  16,  16,  16 },
    {  20,  20,  20 },
    {  24,  24,  24 },
    {  28,  28,  28 },
    {  32,  32,  32 },
    {  36,  36,  36 },
    {  40,  40,  40 },
    {  44,  44,  44 },
    {  48,  48,  48 },
    {  52,  52,  52 },
    {  56,  56,  56 },
    {  60,  60,  60 },
    {  64,  64,  64 },
    {  68,  68,  68 },
    {  72,  72,  72 },
    {  76,  76,  76 },
    {  80,  80,  80 },
    {  84,  84,  84 },
    {  88,  88,  88 },
    {  92,  92,  92 },
    {  96,  96,  96 },
    { 100, 100, 100 },
    { 104, 104, 104 },
    { 108, 108, 108 },
    { 112, 112, 112 },
    { 116, 116, 116 },
    { 120, 120, 120 },
    { 124, 124, 124 },
    { 128, 128, 128 },
    { 132, 132, 132 },
    { 136, 136, 136 },
    { 140, 140, 140 },
    { 144, 144, 144 },
    { 148, 148, 148 },
    { 152, 152, 152 },
    { 156, 156, 156 },
    { 160, 160, 160 },
    { 164, 164, 164 },
    { 168, 168, 168 },
    { 172, 172, 172 },
    { 176, 176, 176 },
    { 180, 180, 180 },
    { 184, 184, 184 },
    { 188, 188, 188 },
    { 192, 192, 192 },
    { 196, 196, 196 },
    { 200, 200, 200 },
    { 204, 204, 204 },
    { 208, 208, 208 },
    { 212, 212, 212 },
    { 216, 216, 216 },
    { 220, 220, 220 },
    { 224, 224, 224 },
    { 228, 228, 228 },
    { 232, 232, 232 },
    { 236, 236, 236 },
    { 240, 240, 240 },
    { 244, 244, 244 },
    { 248, 248, 248 },
    { 252, 252, 252 },

    {   0,   0,   0 },   /* couleur du cadre   */
};


/****************************
 * Declaration des couleurs *
 ****************************/
 
void globa_init_CMS ()
{
  /* Creation du colormap segment pour les canvas */

  cms_palette = (Cms) xv_create (NULL, CMS,   /* vol.7 p.414 */
      CMS_SIZE,              81 + CMS_CONTROL_COLORS,
      CMS_CONTROL_CMS,       TRUE,
      CMS_COLORS,            cms_colors,
      NULL);

 
#ifdef DEBUG
  printf("globa_couleurs\n");
  printf ("CMS_CONTROL_COLORS = %d\n",CMS_CONTROL_COLORS);
#endif

}


void globa_init_LUTS ()
{
  int i, t;

  unsigned long *pixel_table;             /* vol.7 p.412 */

  pixel_table = (unsigned long *) xv_get (cms_palette, CMS_INDEX_TABLE);
  
  glo.c[0] = pixel_table[0];                        /* fond ecran     */
  glo.c[1] = pixel_table[2];                        /* cadre fonce    */
  glo.c[2] = pixel_table[1];                        /* objet enfonce  */
  glo.c[3] = pixel_table[0];                        /* objet au repos */
  glo.c[4] = pixel_table[3];                        /* cadre clair    */
  glo.c[5] = pixel_table[CMS_CONTROL_COLORS+15];    /* blanc          */
  glo.c[6] = pixel_table[CMS_CONTROL_COLORS+0];     /* noir  : encre  */
  
  /*
      Accs aux couleurs :
          coul_tab[1+(i-1)%255]  (un seul noir)
  */
  for (i = 0; i < 16; i++) {
	coul_16c[i] = pixel_table[i + CMS_CONTROL_COLORS]; 
        colR_16c[i] = cms_colors[i].red;
        colG_16c[i] = cms_colors[i].green;
        colB_16c[i] = cms_colors[i].blue;
  }
  for (i = 16; i < 256; i++) {
  	t = ((i - 1) % 15) +1;
	coul_16c[i] = coul_16c[t];
        colR_16c[i] = colR_16c[t];
        colG_16c[i] = colG_16c[t];
        colB_16c[i] = colB_16c[t];
  }

  for (i = 0; i < 256; i++) {
  	t = 16+((i / 4) % 64);
	coul_bwc[i] = coul_64g[i] = pixel_table[t + CMS_CONTROL_COLORS];
	colR_bwc[i] = colR_64g[i] = i;
	colG_bwc[i] = colG_64g[i] = i; /* On prend les 256 niveaux de gris */
	colB_bwc[i] = colB_64g[i] = i;
  }

  for (i = 0; i < 16; i++) {
  	coul_bwc[i] = coul_16c[i];
        colR_bwc[i] = colR_16c[i];
        colG_bwc[i] = colG_16c[i];
        colB_bwc[i] = colB_16c[i];
  }

  coul_pic = coul_16c;

}



/*************************************************************
 *  IPS_COUL_ = glo_get_attr_lut (coul_tab)
 ************************************************************/
int glo_get_attr_lut (coul_tab)
Unt32 *coul_tab;
{
    return (coul_tab == coul_16c) ? IPS_COUL_16C
         : (coul_tab == coul_64g) ? IPS_COUL_64G
         : (coul_tab == coul_bwc) ? IPS_COUL_BWC
         : IPS_COUL_BWC;
}


/*************************************************************
 *  coul_tab = glo_get_ctab_lut (IPS_COUL_)
 ************************************************************/
Unt32 *glo_get_ctab_lut (attr)
int attr;
{
    switch (attr) {
	case IPS_COUL_16C : return coul_16c;
	case IPS_COUL_64G : return coul_64g;
	case IPS_COUL_BWC : return coul_bwc;
	default           : return coul_bwc;
    }
}

Unt8 *glo_get_colR (coul_tab)
Unt32 *coul_tab;
{
    return (coul_tab == coul_16c) ? colR_16c
         : (coul_tab == coul_64g) ? colR_64g
         : (coul_tab == coul_bwc) ? colR_bwc
         : colR_bwc;
}

Unt8 *glo_get_colG (coul_tab)
Unt32 *coul_tab;
{
    return (coul_tab == coul_16c) ? colG_16c
         : (coul_tab == coul_64g) ? colG_64g
         : (coul_tab == coul_bwc) ? colG_bwc
         : colG_bwc;
}

Unt8 *glo_get_colB (coul_tab)
Unt32 *coul_tab;
{
    return (coul_tab == coul_16c) ? colB_16c
         : (coul_tab == coul_64g) ? colB_64g
         : (coul_tab == coul_bwc) ? colB_bwc
         : colB_bwc;
}


