/***************************************************************************************/
/* obj_image.h                                                 I.P.S  v 3.3  18/3/1994 */
/*                                                                                     */
/* gestion de l'objet image (ico->nat_obj = ICO_IMAGE)   Edouard.Thiel@lim.univ-mrs.fr */
/***************************************************************************************/


#define IMAGE_CH1LEN	63
#define IMAGE_CH2LEN	15

/* Type Image */

typedef char Image_name[IMAGE_CH1LEN + 1];

typedef struct {				/* ---- Bornes de l'image -------------	*/
	int		cmin,			/* valeur du cadre ; z = cmin .. zmax	*/
			xsiz, xmax, xtot,	/* kmax  = cmin + ksiz			*/
			ysiz, ymax, ytot,	/* ktot  = cmin + ksiz + cmin		*/
			xytot;			/* xytot = xtot * ytot			*/
	} Bounda;

typedef struct {
	Bounda		b;			/* Bornes de l'image			*/
						/* ---- Hublot dans l'icone ----------- */
	int		hub_xb, hub_yb,		/* coord base du hublot			*/
			hub_xm, hub_ym,		/* taille du hublot			*/
			hub_zoom, hub_step,	/* zoom et step				*/
                        hub_max, hub_ext,       /* max taille hub, epaisseur bord ext   */
			x_ch1, y_ch1, s_ch1,	/* coords de la chaine ch1 et taille	*/
			x_ch2, y_ch2, s_ch2,	/* coords de la chaine ch2		*/
			x_ch3, y_ch3, s_ch3;	/* coords de la chaine ch3		*/
	Image_name	ch1;			/* le titre de l'image			*/
	char		ch2[IMAGE_CH2LEN + 1],	/* "n.index_creat"			*/
			ch3[IMAGE_CH2LEN + 1];	/* taille "y.x"				*/
	Unt16		*tab;			/* pointeur sur l'image (en vectoriel)	*/
        Unt32		*coul_tab;		/* table de couleurs active		*/
	XImage		*hub_xima;		/* XImage prete a etre affichee		*/
	} Image;


extern void		image_calc_bornes		();
extern void		image_creat			();
extern void		image_free 			();
extern void		image_duplic			();
extern void		image_obsolete			();
extern int		image_chg_cad			();
extern void		image_props_creer_frame		();
extern void		image_props_affi_frame		();
extern void		image_props_rescan		();
extern void		image_props_messaProc		();
extern void		image_props_proc		();
extern int		image_props_direct		();
extern void		image_calc_hublot		();
extern void		image_affi_ico			();
extern void		image_affi_hublot		();
extern void		image_prepare_noms		();
extern void		image_CloseAllWin		();
