/***************************************************************************************/
/* obj_macro.c                                                I.P.S  v 3.1  16/12/1993 */
/*                                                                                     */
/* gestion de l'objet macro  (ico->nat_obj = ICO_MACRO)  Edouard.Thiel@lim.univ-mrs.fr */
/***************************************************************************************/


#include "inclus.h"

/*
 * Decoration
*/
static XPoint decoS[] =	{ { 8, 3}, {14, 3}, {12, 3}, { 0, 1}, {28,13}, {16, 0},
			  {24,15}, {27,15}, {19,11}, {24,15}, {19,19}, {15,15} };
#define decoN 12

/*
 * Fenetre props
*/
static Frame		frame_macro_memo;
static Panel_item	panel_macro_memo_name,
			panel_macro_memo_msg_oper,
			panel_macro_memo_msg_in,
			panel_macro_memo_msg_out;
static Ico		*ico_macro_memo;
static int		macro_memo_l_act[OPER_VECM],
			macro_memo_l_in[OPER_VECM],
			macro_memo_n_act = 0,
			macro_memo_n_in = 0;

/****************************************************************************************
 * FUNCTION  : macro_creat (MaCom *ma)
 *
 * PURPOSE   : 
 *
 * CALLED IN : 
 *
 ***************************************************************************************/
void macro_creat (ma)
MaCom *ma;
{
    ma->n_act		= 0;			/* nb d'operateurs dans la macro	*/
    ma->n_in		= 0;			/* nb d'entrees				*/
    ma->n_out		= 0;			/* nb de sorties			*/
    ma->l_act		= NULL;			/* liste des op				*/
    ma->l_in		= NULL;			/* liste des entrees			*/
    ma->l_out		= NULL;			/* liste des sorties			*/
    ma->titre		= NULL;			/* nom de la macro			*/
    ma->mot_x		= 10;			/* largeur max des sous titres		*/
    ma->etat_led	= 0;			/* etat du voyant			*/
}
 
/****************************************************************************************
 * FUNCTION  : macro_free (MaCom *ma)
 *
 * PURPOSE   : 
 *
 * CALLED IN : 
 *
 ***************************************************************************************/
void   macro_free (ma)
MaCom *ma;
{
    /* titre de la macro */
    pcp_free (ma->titre);

    /* tableaux de la macro */
    pcp_free (ma->l_act);
    pcp_free (ma->l_in);
    pcp_free (ma->l_out);
}
 
/****************************************************************************************
 * FUNCTION  : macro_duplic ( Ico *ico_new, *ico_old );
 *
 * PURPOSE   : Duplication de l'icone IPS_MACRO : ico_n := ico_o
 *
 * CALLED IN : method_duplic
 *
 ***************************************************************************************/
void  macro_duplic (ico_n, ico_o)
Ico  *ico_n, *ico_o;
{ 
    MaCom *ma_o = (MaCom *) ico_o->obj;
    MaCom *ma_n = (MaCom *) ico_n->obj;

    memcpy (ma_n, ma_o, sizeof(MaCom));

    /* nom de la macro */
    ma_n->titre = stg_Cpy (ma_o->titre);

    /* tableaux de la macro */
    ma_n->l_act = (ma_o->n_act == 0) ? NULL
	: (int *) pcp_alloc (ma_o->n_act * sizeof (int));
    if (ma_n->l_act != NULL)
	memcpy (ma_n->l_act, ma_o->l_act, ma_o->n_act * sizeof (int));

    ma_n->l_in = (ma_o->n_in == 0) ? NULL
	: (int *) pcp_alloc (ma_o->n_in * sizeof (int));
    if (ma_n->l_in != NULL)
	memcpy (ma_n->l_in, ma_o->l_in, ma_o->n_in * sizeof (int));

    ma_n->l_out = (ma_o->n_out == 0) ? NULL
	: (int *) pcp_alloc (ma_o->n_out * sizeof (int));
    if (ma_n->l_out != NULL)
	memcpy (ma_n->l_out, ma_o->l_out, ma_o->n_out * sizeof (int));
}
 
/****************************************************************************************
 * FUNCTION  : macro_affi_ico ( Ico *ico );
 *
 * PURPOSE   : Afficher l'icone IPS_MACRO
 *
 * CALLED IN : method_affi_ico
 *
 ***************************************************************************************/
void  macro_affi_ico (ico)
Ico  *ico;
{
    MaCom *ma = (MaCom *) ico->obj;
    int    a3, n, x, y, i, c, l;
    char   bla[256];
    XPoint dS[decoN], *dA, *dB;

    stg_PrintCenter (ico->xb+ico->xm/2, ico->yb+2, ma->mot_x, ma->titre);

    switch (ma->etat_led) 
    {
      case 0  : a3 = 10; break;	/* sleep   */
      case 1  : a3 =  6; break;	/* wait    */
      case 2  : a3 = 12; break;	/* running */
      case 3  : a3 =  9; break;	/* attach  */
      default : a3 =  0; break;
    }

    /* prepare coords du decor */
    x = ico->xb + (ico->xm-36)/2;
    y = ico->yb + ico->ym-24;
    for (i = 0; i < decoN; i++) {
	dS[i].x = decoS[i].x + x;
	dS[i].y = decoS[i].y + y;
    }
    /* liens entre boites */
    XSetForeground (glo.dpy, glo.gc, glo.c[6]);
    XDrawLine      (glo.dpy, glo.xwin, glo.gc, dS[0].x, dS[0].y, dS[1].x, dS[1].y );
    XDrawLine      (glo.dpy, glo.xwin, glo.gc, dS[6].x, dS[6].y, dS[7].x, dS[7].y );
    XDrawRectangle (glo.dpy, glo.xwin, glo.gc, dS[2].x, dS[2].y, 7, 12);

    /* boites */
    XSetForeground (glo.dpy, glo.gc, coul_pic[a3]);
    XFillRectangle (glo.dpy, glo.xwin, glo.gc, dS[3].x, dS[3].y, 8, 5);
    XFillRectangle (glo.dpy, glo.xwin, glo.gc, dS[4].x, dS[4].y, 8, 5);
    XFillPolygon   (glo.dpy, glo.xwin, glo.gc, dS+8, 4, Convex, CoordModeOrigin);
    XFillArc       (glo.dpy, glo.xwin, glo.gc, dS[5].x, dS[5].y, 7, 7, 0, 360*64);
}

/****************************************************************************************
 * FUNCTION  : macro_prepare_noms ( Ico *ico, char *titre );
 *
 * PURPOSE   : Calcule les coords des sous titres de l'IPS_MACRO
 *
 * CALLED IN :
 *
 ****************************************************************************************/
void  macro_prepare_noms (ico, titre)
Ico  *ico;
char *titre;
{
    MaCom *ob = (MaCom *) ico->obj;
    char bla[500];
    int nb;

    if (titre == NULL) ob->titre = stg_Cpy ("WARNING: Macro without name");

    /* Normalise espaces */
    stg_NormSpace (titre, bla);
    pcp_free (ob->titre);
    ob->titre = stg_Cpy (bla);

    /* Repartit les mots */
    stg_RepartiMots (bla, &(ob->mot_x), &nb);

    /* calcul de ico->xm, ico->ym */
    ico->ym = 3 + nb*(glo.font_h+2) + 16+15;
    ico->xm = max (ob->mot_x * glo.font_l + 14, 16+36);
}

/****************************************************************************************
 * FUNCTION  : 
 *
 * PURPOSE   : Creation de la boite de dialogue de la memorisation d'une macro
 *
 * CALLED IN : 
 *
 ***************************************************************************************/
void macro_memo_creer_frame ()
{ 
    Panel   panel;

    frame_macro_memo = (Frame) xv_create (glo.frame_principal, FRAME_CMD,
	FRAME_LABEL,	"Macro Memo",
	NULL);

    panel = (Panel) xv_get (frame_macro_memo, FRAME_CMD_PANEL);
    xv_set (panel, PANEL_LAYOUT, PANEL_VERTICAL, NULL);
  
    panel_macro_memo_name = (Panel_item) xv_create (panel, PANEL_TEXT,
	PANEL_LABEL_STRING,         "Name :",
	PANEL_VALUE,                "",
	PANEL_VALUE_DISPLAY_LENGTH, 25,
	PANEL_VALUE_STORED_LENGTH,  255,
	NULL);

    (void) xv_create (panel, PANEL_BUTTON,   
	PANEL_LABEL_STRING,	"Actions",
	PANEL_NOTIFY_PROC,	macro_memo_proc,
	NULL);

    xv_set (panel, PANEL_LAYOUT, PANEL_HORIZONTAL, NULL);

    panel_macro_memo_msg_oper = (Panel_item) xv_create (panel, PANEL_MESSAGE,
	XV_X, 100, NULL);

    xv_set (panel, PANEL_LAYOUT, PANEL_VERTICAL, NULL);

    (void) xv_create (panel, PANEL_BUTTON,   
	PANEL_LABEL_STRING,	"Datas In",
	PANEL_NOTIFY_PROC,	macro_memo_proc,
	NULL);

    xv_set (panel, PANEL_LAYOUT, PANEL_HORIZONTAL, NULL);

    panel_macro_memo_msg_in = (Panel_item) xv_create (panel, PANEL_MESSAGE,
	XV_X, 100, NULL);

    xv_set (panel, PANEL_LAYOUT, PANEL_VERTICAL, NULL);

    (void) xv_create (panel, PANEL_BUTTON,   
	PANEL_LABEL_STRING,	"Datas Out",
	PANEL_NOTIFY_PROC,	macro_memo_proc,
	PANEL_INACTIVE,		TRUE,
	NULL);

    xv_set (panel, PANEL_LAYOUT, PANEL_HORIZONTAL, NULL);

    panel_macro_memo_msg_out = (Panel_item) xv_create (panel, PANEL_MESSAGE,
	XV_X, 100, NULL);

    xv_set (panel, PANEL_LAYOUT, PANEL_VERTICAL, NULL);

    (void) xv_create (panel, PANEL_BUTTON,   
	PANEL_LABEL_STRING,	"Apply",
	PANEL_NOTIFY_PROC,	macro_memo_proc,
	NULL);

    window_fit (panel);
    window_fit (frame_macro_memo);
}
 
/****************************************************************************************
 * FUNCTION  : 
 *
 * PURPOSE   : Mise en place des param dans la boite de dialogue de la memo d'une macro
 *
 * CALLED IN : 
 *
 ***************************************************************************************/
void macro_memo_affi_frame (ico)
Ico *ico;
{ 
    MaCom *ma = (MaCom *) ico->obj;
    int    mx = (int) xv_get (glo.frame_principal, XV_X) + ico->xb;
    int    my = (int) xv_get (glo.frame_principal, XV_Y) + ico->yb;
    char   bla[100];

    xv_set (panel_macro_memo_name, PANEL_VALUE, ma->titre, NULL);
    macro_memo_n_act = ma->n_act;
    macro_memo_n_in = ma->n_in;
    memcpy (macro_memo_l_act, ma->l_act, ma->n_act * sizeof (int));
    memcpy (macro_memo_l_in, ma->l_in, ma->n_in * sizeof (int));
    sprintf (bla, "%d", ma->n_act);
    xv_set (panel_macro_memo_msg_oper, PANEL_LABEL_STRING, bla, NULL);
    sprintf (bla, "%d", ma->n_in);
    xv_set (panel_macro_memo_msg_in, PANEL_LABEL_STRING, bla, NULL);
    xv_set (frame_macro_memo, XV_X, mx, XV_Y, my, XV_SHOW, TRUE,
	FRAME_CMD_PUSHPIN_IN, TRUE, NULL);
    ico_macro_memo = ico;
}

/****************************************************************************************
 * FUNCTION  : 
 *
 * PURPOSE   : Notify proc de la boite de dialogue de la memo d'une macro
 *
 * CALLED IN : 
 *
 ***************************************************************************************/
void macro_memo_proc (item, event)
Panel_item item;
Event *event;
{ 
    char  *bouton  = (char*) xv_get (item, PANEL_LABEL_STRING);
    char  *name    = (char*) xv_get (panel_macro_memo_name, PANEL_VALUE);
    Ico   *ico     = ico_macro_memo;
    MaCom *ma      = (MaCom *) ico->obj;
    int    mx      = (int) xv_get (glo.canvas, XV_X) + ico->xb + ico->xm/2;
    int	   my      = (int) xv_get (glo.canvas, XV_Y) + ico->yb + ico->ym/2;
    int    cas     = -1;
    int    o_xm    = ico->xm;
    int    o_ym    = ico->ym;
    int    raf_ico = FAUX;
    int    test, i, n;
    char   bla[100];

    if      (!strcmp (bouton, "Apply"       )) cas = 1;
    else if (!strcmp (bouton, "Actions"     )) cas = 2;
    else if (!strcmp (bouton, "Datas In"    )) cas = 3;
    else if (!strcmp (bouton, "Datas Out"   )) cas = 4;

    if (cas == 2 || cas == 3) { /* Actions, Datas In */

	Ico *cur = glo.l_ico_a,
	    *p[OPER_VECM];
	n = 0;
        test = VRAI;

	if (cas == 2)
	     sprintf (bla, "Only Actions");
	else sprintf (bla, "Only Datas");

	while (cur != NULL && test) {
	    if (cur->sel) {
		if ((cas == 2 && IPS_IS_DATA(cur->nat_obj)) ||
		    (cas != 2 && IPS_IS_ACTION(cur->nat_obj))) {
		    pcp_avertis_xy ("WARNING !",
			bla, "are required", mx, my);
		    test = FAUX;
		}
		else if (n >= OPER_VECM) test = FAUX;
		else if (cur->index_creat != ico->index_creat)
		    ico_tri_selec (cur, p, 0, n++);  /* tri par insertion */
	    }
	    cur = cur->pa;
	}

	if (test) switch (cas) {

	    case 2 : /* Actions */
		macro_memo_n_act = n;
		for (i = 0; i < n; i++) macro_memo_l_act[i] = p[i]->index_creat;
		sprintf (bla, "%d", n);
		xv_set (panel_macro_memo_msg_oper, PANEL_LABEL_STRING, bla, NULL);
		break;

	    case 3 : /* Datas In */
		macro_memo_n_in = n;
		for (i = 0; i < n; i++) macro_memo_l_in[i] = p[i]->index_creat;
		sprintf (bla, "%d", n);
		xv_set (panel_macro_memo_msg_in, PANEL_LABEL_STRING, bla, NULL);
		break;
	}

    } /* Actions, Datas In */

    if (cas == 1) {

        /* changement de nom */
	if (strcmp (ma->titre, name)) {
	    macro_prepare_noms (ico, name);
	    xv_set (panel_macro_memo_name, PANEL_VALUE, ma->titre, NULL);
	    raf_ico = VRAI;
	}

	/* liste _act */
	ma->n_act = macro_memo_n_act;
	pcp_free (ma->l_act);
	ma->l_act = (macro_memo_n_act == 0) ? NULL
	    : (int *) pcp_alloc (macro_memo_n_act * sizeof (int));
	if (ma->l_act != NULL)
	    memcpy (ma->l_act, macro_memo_l_act, macro_memo_n_act * sizeof (int));

	/* liste _in */
	ma->n_in = macro_memo_n_in;
	pcp_free (ma->l_in);
	ma->l_in = (macro_memo_n_in == 0) ? NULL
	    : (int *) pcp_alloc (macro_memo_n_in * sizeof (int));
	if (ma->l_in != NULL)
	    memcpy (ma->l_in, macro_memo_l_in, macro_memo_n_in * sizeof (int));

	xv_set (frame_macro_memo, FRAME_CMD_PUSHPIN_IN, FALSE, XV_SHOW, FALSE, NULL);
   }

    /* MAJ affi de l'ico */
    if (raf_ico) {
        method_obsolete (ico);
        ico_homot_clic (ico, ico->xb, ico->yb, o_xm, o_ym, ico->xm, ico->ym);
    }

}

/****************************************************************************************
 * FUNCTION  : 
 *
 * PURPOSE   : retrouve icones et si possible appelle macro_exec
 *
 * CALLED IN : 
 *
 ***************************************************************************************/
void macro_check_run (ico_ma)
Ico *ico_ma;
{
    Ico		*p[OPER_VECM], *cur;
    MaCom	*ma  = (MaCom *) ico_ma->obj;
    int		mx   = (int) xv_get (glo.canvas, XV_X) + ico_ma->xb + ico_ma->xm/2;
    int		my   = (int) xv_get (glo.canvas, XV_Y) + ico_ma->yb + ico_ma->ym/2;
    int		n2   = ma->n_in + ma->n_out;
    int		n, i, test;
    char	bla[200];

    /*
     * init
    */
    for (i = 0; i < OPER_VECM; i++) p[i] = NULL;
    test = VRAI; n = 0;

    /*
     * retrouver la selection, tri et tests
    */
    cur = glo.l_ico_a;
    while (cur != NULL && test) {
	if (cur->sel) { 
	    if (IPS_IS_DATA(cur->nat_obj)) {
		n++;
		if (n > n2) {
		    test = FAUX;
		    sprintf (bla, "%d in and %d out\n",
			ma->n_in, ma->n_out);
		    pcp_avertis_xy ("WARNING !",
			"Number of datas needed by this macro :",bla, mx, my);
		}
		else ico_tri_selec (cur, p, 1, n);  /* tri par insertion */
	    }

	    else if (cur->index_creat != ico_ma->index_creat) {
		test = FAUX;
		pcp_avertis_xy ("WARNING !","",
		    "Only datas must be selected", mx, my);
	    }
	}
	cur = cur->pa;
    }

    p[0] = ico_ma;
    if (test) macro_exec (p, n);
}

/****************************************************************************************
 * FUNCTION  : 
 *
 * PURPOSE   : execution de la macro
 *
 * CALLED IN : 
 *
 ***************************************************************************************/
int macro_exec (p, n)
Ico **p;
int n;
{
    Ico		*ico_ma = p[0];
    MaCom	*ma = (MaCom *) ico_ma->obj;
    Ico		*cur, *appel;
    int		n1, n2, i, j, appel_n, trouve;
    int		mx   = (int) xv_get (glo.canvas, XV_X) + ico_ma->xb + ico_ma->xm/2;
    int		my   = (int) xv_get (glo.canvas, XV_Y) + ico_ma->yb + ico_ma->ym/2;
    char	bla[200];
    int		exec_poss = VRAI;
    int		test = VRAI;

    /*
     * Nombre d'images en entree et en sortie
    */
    n1 = ma->n_in;
    n2 = ma->n_in + ma->n_out;

    /****************************
     * TESTE le nombre de donnees
    */
    if (n < n1) {
	sprintf (bla, "%d in and %d out\n", ma->n_in, ma->n_out);
	pcp_avertis_xy ("WARNING !","Number of datas needed by this macro :",bla, mx, my);
	return FAUX;
    }

    /*
     * etat_led = execution - ATTENTION : plus de return avant la fin
    */
    for (appel_n = 0; appel_n < ma->n_act && test; appel_n++) {

	/*
	 * etat_led
	*/
	ma->etat_led = 2; /* run */
	ico_refresh_now (ico_ma);

	/*
	 * Retrouver action `appel'
	*/
	appel = ico_get_from_index_creat (ma->l_act[appel_n]);

	if (appel == (Ico *) NULL) {
	    test = FAUX;
	    pcp_avertis_xy ("WARNING !","an action icon",
		"is lost", mx, my);
	}

	/*
	 * Retrouver donnees
	*/
	else {

	    Ico *q[OPER_VECM];
	    int  data_v[OPER_VECM];
	    int  data_n = 0;
	    int  m = 0;

	    /*
	     * tient compte selection
	    */
	    switch (appel->nat_obj) {
		case IPS_OPER : {
		    Oper *appel_op = (Oper *) appel->obj;
		    data_n = appel_op->attach_n;
		    for (i = 0; i < appel_op->attach_n; i++) {
			int toz = FAUX;
			for (j = 0; j < ma->n_in; j++)
			    if (appel_op->attach_v[i] == ma->l_in[j]) {
				toz = VRAI; break;
			    }
			data_v[i] = (toz) ? p[j+1]->index_creat : appel_op->attach_v[i];
		    }
		} break;
		case IPS_MACRO : {
		    test = FAUX;
		    pcp_avertis_xy ("DESOLE !!!","Pour le moment une macro ne peut pas",
			"encore en appeler une autre", mx, my);
		    /* RAISON : prevoir `attach' pour une macro */
		} break;
	    }

	    /*
	     * retrouve les donnees data_v[] et les mets dans q[]
	    */
	    if (test) {
		for (i = 0; i < data_n && test; i++) {
		    cur = ico_get_from_index_creat (data_v[i]);
		    if (cur != (Ico *) NULL)
			q[++m] = cur;
		    else {
			test = FAUX;
			pcp_avertis_xy ("WARNING !","an attached icon",
			    "is lost", mx, my);
			break;
		    }
		}
	    }

	    /*
	     * execution
	    */
	    q[0] = appel;
	    if (test) switch (appel->nat_obj) {
		case IPS_OPER :
		    test = oper_exec (q, m);
		    break;
		case IPS_MACRO :
		    test = macro_exec (q, m);
		    break;
	    }
	} 

    } /* for appel_n */

    /*
     * etat_led = 0 ; 3 si attach !!!
    */
    ma->etat_led = 0; /* sleep */
    ico_refresh_now (ico_ma);

    return test;
}

/****************************************************************************************
 * FUNCTION  : 
 *
 * PURPOSE   : Creation du bouton et du menu "Macro" du frame_principal
 *
 * CALLED IN : 
 *
 ***************************************************************************************/
Panel_item macro_FramePcpButtCreat (panel)
Panel panel;
{
    Menu menu  = (Menu) xv_create (NULL, MENU,
	MENU_STRINGS,		"...", NULL,
	MENU_NOTIFY_PROC,	macro_FramePcpMenuProc,
	NULL);

    return (Panel_item) xv_create (panel, PANEL_BUTTON,   
	PANEL_LABEL_STRING,	"Macro",
	PANEL_ITEM_MENU,	menu,
	NULL);
}

/****************************************************************************************
 * FUNCTION  : 
 *
 * PURPOSE   : Activation du choix dans le menu "Macro" du frame_principal
 *
 * CALLED IN : 
 *
 ***************************************************************************************/
void macro_FramePcpMenuProc (menu, menu_item)
Menu menu;
Menu_item menu_item;
{
    char *menu_str = (char *) xv_get (menu_item, MENU_STRING);

}

/****************************************************************************************
 * FUNCTION  : macro_CloseAllWin (Ico *ico);
 *
 * CALLED IN : method_free
 *
 ****************************************************************************************/
void macro_CloseAllWin (ico)
Ico *ico;
{
    MaCom *ma = (MaCom *) ico->obj;
  
    /* fenetre Memo */
    if (ico == ico_macro_memo) {
	xv_set (frame_macro_memo, FRAME_CMD_PUSHPIN_IN, FALSE, XV_SHOW, FALSE, NULL);
	ico_macro_memo = NULL;
    }
}
