/***************************************************************************************/
/* obj_matri.c                                                I.P.S  v 3.1  18/11/1993 */
/*                                                                                     */
/* gestion de l'objet matri (ico->nat_obj = ICO_MATRI)   Edouard.Thiel@lim.univ-mrs.fr */
/***************************************************************************************/


#include "inclus.h"

/****************************************************************************************
 * FUNCTION  : 
 *
 * PURPOSE   : 
 *
 * CALLED IN : 
 *
 ***************************************************************************************/
void matri_init (ma)
Matri *ma;
{
  ma->xtot	= 0;				/* taille de la matrice	en x		*/
  ma->ytot	= 0;				/* taille de la matrice	en y		*/
  ma->tit_n	= 0;				/* nombre de sous titres		*/
  ma->titre	= NULL;				/* titre de la matri			*/
  ma->tab	= NULL;				/* tableau de la matrice		*/
  ma->frame_edi	= NULL;				/* Frame d'edition de la matri		*/
}
 
/****************************************************************************************
 * FUNCTION  : 
 *
 * PURPOSE   : 
 *
 * CALLED IN : 
 *
 ***************************************************************************************/
void   matri_free (ma)
Matri *ma;
{
  /* titre de la matri */
  pcp_free (ma->titre);

  /* tableau de la matri */
  pcp_free (ma->tab);
}
 
/****************************************************************************************
 * FUNCTION  : matri_duplic ( Ico *ico_new, *ico_old );
 *
 * PURPOSE   : Duplication de l'icone IPS_MATRIX : ico_n := ico_o
 *
 * CALLED IN : method_duplic
 *
 ***************************************************************************************/
void  matri_duplic (ico_n, ico_o)
Ico  *ico_n, *ico_o;
{ 
  Matri *ma_o = (Matri *) ico_o->obj;
  Matri *ma_n = (Matri *) ico_n->obj;
  int   xytot = ma_o->xtot * ma_o->ytot;

  memcpy (ma_n, ma_o, sizeof(Matri));

  /* titre de la matri */
  ma_n->titre = stg_Cpy (ma_o->titre);

  /* tableau de la matri */
  if (ma_o->tab != NULL) {
    ma_n->tab = (double *) pcp_alloc (xytot * sizeof (double));
    memcpy (ma_n->tab, ma_o->tab, xytot);
  }

  /* fenetre d'edition */
  ma_n->frame_edi = NULL;
}
 
/****************************************************************************************
 * FUNCTION  : matri_affi_ico ( Ico *ico );
 *
 * PURPOSE   : Afficher l'icone IPS_MATRIX
 *
 * CALLED IN : method_affi_ico
 *
 ***************************************************************************************/
void  matri_affi_ico (ico)
Ico  *ico;
{
  Matri *ma = (Matri *) ico->obj;
  int   n;

  XSetForeground (glo.dpy, glo.gc, glo.c[6]);

  for (n = 0; n < ma->tit_n; n++)
  XDrawString (glo.dpy, glo.xwin, glo.gc, 
               ico->xb+ma->tit_x[n], ico->yb+ma->tit_y[n], 
               ma->titre+ma->tit_deb[n], ma->tit_len[n]);
}

/****************************************************************************************
 * FUNCTION  : matri_prepare_noms ( Ico *ico );
 *
 * PURPOSE   : Calcule les coords des sous titres de l'IPS_MATRI
 *
 * CALLED IN :
 *
 ****************************************************************************************/
void  matri_prepare_noms (ico)
Ico  *ico;
{
  Matri *ma = (Matri *) ico->obj;

}

/****************************************************************************************
 * FUNCTION  : matri_frame_kill (Frame frame);
 *
 * PURPOSE   : FRAME_DONE_PROC
 *
 ****************************************************************************************/
void  matri_frame_kill (frame)
Frame frame;
{
  Matri_edi *p = (Matri_edi *) xv_get (frame, WIN_CLIENT_DATA);

  if (xv_destroy_safe(frame) != XV_OK) pcp_error ("matri_frame_kill #01", NULL);

  p->matri->frame_edi = NULL;
  pcp_free(p);
}

/****************************************************************************************
 * FUNCTION  : matri_CloseAllWin (Ico *ico);
 *
 * CALLED IN : method_free
 *
 ****************************************************************************************/
void matri_CloseAllWin (ico)
Ico *ico;
{
    Matri *ma = (Matri *) ico->obj;
  
    /* fenetre d'edition */
    if (ma->frame_edi != NULL) matri_frame_kill (ma->frame_edi);
}
