/***************************************************************************************/
/* principal.c                                                I.P.S  v 3.8a  01/2/1998 */
/*                                                                                     */
/* module principal                                      Edouard.Thiel@lim.univ-mrs.fr */
/***************************************************************************************/

#include "inclus.h"

#define DATE_RELEASE	"Jan 07 2003"
#define NUMERO_VERSION	"3.8c"
#define DATE_COPYRIGHT	"1993-99"



/***************************************************************************************
 * MAIN                                                                                *
 *                                                                                     *
 ***************************************************************************************/
main (argc,argv)
int argc;
char *argv[];
{
 /****************************
  * Variables locales a main *
  ****************************/
  Panel panel;
  int	i, n, r;
  char  bla[256];
  static char null_string = 0;

  /* icone ips */
  Xv_opaque		icone1_image;
  static unsigned short	icone1_bits[] = {
#   include "icones/ver4.icon"
  };
  Xv_opaque		icone1_image_mask;
  static unsigned short	icone1_mask_bits[] = {
#   include "icones/ver4_mask.icon"
  };


 /************************
  * Initialisation de XV *
  ************************/
#ifdef DEBUG
  printf("Initialisation de XV\n");
#endif
  glo.server = xv_init (XV_INIT_ARGC_PTR_ARGV, &argc, argv, NULL);


 /*************************************************
  * Initialisation des variables de l'application *
  *************************************************/

  glo.nb_alloc = 0;
  ico_init ();
  globa_init_CMS ();
  edi_init_generale ();

  /* chemin de l'application */
  n = 0;
  for (i = 0; argv[0][i]; i++) if (argv[0][i] == '/') n = i+1;
  if ((glo.chemin = (char *) malloc (n+1)) == (char *) NULL)
    { printf ("MALLOC ERROR for glo.chemin\n"); exit(0); }
  for (i = 0; i < n; i++) glo.chemin[i] = argv[0][i];
  glo.chemin[n] = 0;

  /* home directory */
  glo.home_dir = (char *) getenv ("HOME");
  if (glo.home_dir == NULL) {
	printf ("WARNING, environment variable HOME is not set\n");
	glo.home_dir = &null_string;
  }

  /* hostname */
  glo.host_name = (char *) getenv ("HOST");
  if (glo.host_name == NULL) {
	printf ("WARNING, environment variable HOST is not set\n");
	glo.host_name = &null_string;
  }

  /* Intervale de temps max pour double clic souris */
  glo.clic_timeout =  0.1 * (double) defaults_get_integer 
    ("openwindows.multiclicktimeout","OpenWindows.MultiClickTimeout", 4);
  glo.clic_time = glo.clic_time_prev = 0;

  /* socket */
  cs_init();

  /* grammaire itml */
  /* ACTUELLEMENT MIS HORS SERVICE
  if ((r = itml_initGeneral ()) < 0) {
	printf ("ERREUR %d dans itml_initGeneral\n", r);
	exit (0);
  } */
  

  /*************************
   * Declaration icone IPS *
   *************************/

  icone1_image = xv_create(XV_NULL, SERVER_IMAGE,
	/* SERVER_IMAGE_DEPTH, 1, */
	SERVER_IMAGE_BITS, icone1_bits,
	XV_WIDTH, 64,
	XV_HEIGHT, 64,
	NULL);

  icone1_image_mask = xv_create(XV_NULL, SERVER_IMAGE,
	/* SERVER_IMAGE_DEPTH, 1, */
	SERVER_IMAGE_BITS, icone1_mask_bits,
	XV_WIDTH, 64,
	XV_HEIGHT, 64,
	NULL);

  /**************************
   * Declaration des frames *
   **************************/

  sprintf (bla, "I.P.S v "NUMERO_VERSION"  [%s]", glo.host_name);

  glo.frame_principal = (Frame) xv_create (NULL, FRAME, 
	FRAME_LABEL,              bla,
	FRAME_SHOW_FOOTER,        TRUE,
	XV_X,                     0,
	XV_Y,                     0,
	FRAME_NO_CONFIRM,         TRUE,
	FRAME_ICON, xv_create(XV_NULL, ICON,
			ICON_IMAGE, icone1_image,
			ICON_MASK_IMAGE, icone1_image_mask,
			NULL),
      NULL);

  /* Dtourne la destruction du frame principal */
  notify_interpose_destroy_func (glo.frame_principal, pcp_destroy_func);
 
  /* Detourne signal USR1 pour [Reread Menus] */
 /*
  *   notify_set_signal_func(glo.frame_principal, pcp_sigusr1_handler, 
  * 	SIGUSR1, NOTIFY_ASYNC);
  *
  * Actuellement dconnect, car un signal reu pendant que un menu est
  * affich plante IPS (SIGSEGV dans menu_client_window_event_proc()).
  * Il faudrait trouver un moyen de faire un menu_hide(), mais cette
  * fonction n'est pas disponible ou publique.
  *
  * On se sert de SIGUSR1 dans util/Create_index
  */

  dta_matrix_creer_frame   ();
  image_props_creer_frame  ();
  fichier_load_creer_frame ();
  fichier_save_creer_frame ();
  aide_creer_frame         ();
  macro_memo_creer_frame   ();
  ho_creer_frame           ();

 /*******************
  * Frame principal *
  *******************/

  glo.panel1 = (Panel) xv_create (glo.frame_principal, PANEL, NULL);

  (void) fichier_FramePcpButtCreat (glo.panel1);	/* File		*/

  (void) method_FramePcpButtCreat (glo.panel1);		/* New		*/

  (void) oper_FramePcpButtCreat (glo.panel1);		/* Oper		*/

/*  (void) macro_FramePcpButtCreat (glo.panel1);		/* Macro	*/

  (void) lmt_FramePcpButtCreat (glo.panel1);		/* tool_menu 	*/

  (void) pcp_FramePcpButtCreat (glo.panel1);		/* Extra	*/


 /********************
  * Canvas principal *
  ********************/

  glo.canvas = (Canvas) xv_create (glo.frame_principal, CANVAS,
      WIN_CMS,                cms_palette,
   /* WIN_BACKGROUND_COLOR,   16+CMS_CONTROL_COLORS, */
      XV_Y,                   28,
      CANVAS_AUTO_SHRINK,     TRUE,
      CANVAS_AUTO_EXPAND,     TRUE,
      CANVAS_X_PAINT_WINDOW,  TRUE,
      CANVAS_REPAINT_PROC,    ico_repaint,
      CANVAS_RESIZE_PROC,     ico_resize,
      NULL);

  xv_set (canvas_paint_window (glo.canvas),
      WIN_EVENT_PROC,         ico_event_proc,
      WIN_CONSUME_EVENTS,
          WIN_MOUSE_BUTTONS,
          LOC_DRAG,
          NULL,
      NULL);

  glo.sel_req = xv_create (glo.canvas, SELECTION_REQUESTOR,
	SEL_REPLY_PROC, sd_req_reply,
	NULL);

  glo.drop_site = xv_create (canvas_paint_window (glo.canvas), DROP_SITE_ITEM,
      DROP_SITE_REGION,       xv_get (canvas_paint_window (glo.canvas), WIN_RECT),
  /*  DROP_SITE_EVENT_MASK,   DND_ENTERLEAVE | DND_MOTION, */
      DROP_SITE_DEFAULT,      TRUE,
      NULL);

  glo.dpy    = (Display *) xv_get (canvas_paint_window (glo.canvas), XV_DISPLAY);
  glo.p_win  = (Xv_Window) xv_get (glo.canvas, CANVAS_NTH_PAINT_WINDOW, 0);
  glo.xwin   = (Window)    xv_get (glo.p_win, XV_XID);
  glo.screen = DefaultScreen (glo.dpy);
  glo.visual = DefaultVisual (glo.dpy, glo.screen);
  glo.depth  = DefaultDepth  (glo.dpy, glo.screen);
  glo.gc     = DefaultGC     (glo.dpy, glo.screen);
  glo.scr_xm = DisplayWidth  (glo.dpy, glo.screen);
  glo.scr_ym = DisplayHeight (glo.dpy, glo.screen); 

  CoulxInit (glo.dpy, glo.visual, glo.depth);
  /* CoulxAffiInfos(); */
  globa_init_LUTS();
  
#ifdef DEBUG
  printf ("Taille ecran : X %d  Y %d\n", glo.scr_xm, glo.scr_ym);
  printf ("MultiClickTimeout %f\n", glo.clic_timeout);
#endif

  glo.petite_fonte = (Xv_Font) xv_find (glo.canvas, FONT,    /* vol.7 p.319 */
      FONT_NAME,            "courier-10",
      FONT_STYLE,           FONT_STYLE_NORMAL,
      FONT_SIZE,            10,
      NULL);

  if (glo.petite_fonte == NULL) 
       pcp_error ("main #01","Font allocation error", NULL);
  else {
         XFontStruct *font_info;
         Font_string_dims dims;
         XSetFont (glo.dpy, glo.gc, (Font) xv_get (glo.petite_fonte, XV_XID));   /* vol.2 p.415 */
         font_info = (XFontStruct *) xv_get (glo.petite_fonte, FONT_INFO); /*vol.7 p.326 */
         glo.font_a = font_info->ascent;   /* vol.1 p.152 */
         glo.font_d = font_info->descent;
         glo.font_h = glo.font_a + glo.font_d;
         (void) xv_get (glo.petite_fonte, FONT_STRING_DIMS, " ", &dims);
         glo.font_l = dims.width;
       }

  glo.nb_alloc = 0;
  xv_set (glo.frame_principal, FRAME_RIGHT_FOOTER,
      "Here # of allocated pointers", NULL);

 /***********************************************************************
  * Boucle principale XV 
  *
  * Attention, mettre "__PC0__PCSTART ();" pour l'appel des I/O en Pascal
  * juste AVANT xv_main_loop (sans commentaire entre !!)
  ***********************************************************************/

#ifdef USE_PASCAL
  __PC0__PCSTART (); 
  xv_main_loop (glo.frame_principal);
#else
  xv_main_loop (glo.frame_principal);
#endif
}



/***************************************************************************************
 * Demande confirmation pour quitter l'application et liberer la memoire               *
 *                                                                                     *
 ***************************************************************************************/

Notify_value
pcp_destroy_func (client, status)  /* V.7 p.484 */
Notify_client client;
Destroy_status status;
{
    if (status == DESTROY_CHECKING) {

	int result = notice_prompt(glo.panel1, NULL,
	    NOTICE_MESSAGE_STRINGS,  "Please confirm exit from I.P.S", NULL,
	    NOTICE_BUTTON_YES,       "Cancel",
	    NOTICE_BUTTON_NO,        "Quit",
	    NOTICE_NO_BEEPING,       TRUE,
	    NULL);

	if (result == NOTICE_YES) notify_veto_destroy (client);

    } else if (status == DESTROY_CLEANUP) {

	cs_quit (); /* suppression du socket */

#ifdef USE_PASCAL
	__PC0__PCEXIT (); 
#endif
	return notify_next_destroy_func (client, status);
    } 

    return NOTIFY_DONE;
}


void
pcp_quit ()
{

#ifdef c_est_l_ancienne_version
  int result;

  result = notice_prompt(glo.panel1, NULL,
      NOTICE_MESSAGE_STRINGS,  "Please confirm exit from I.P.S", NULL,
      NOTICE_BUTTON_YES,       "Quit",
      NOTICE_BUTTON_NO,        "Cancel",
      NULL);

  if (result == NOTICE_YES)
  {
    __PC0__PCEXIT ();  /* Fin des I/O en Pascal */

    if (xv_destroy_safe(glo.frame_principal) == XV_OK)
    exit(0);
  }
#endif

    xv_destroy_safe(glo.frame_principal);
}

/***************************************************************************************
 * Affiche le frame attache au PANEL_CLIENT_DATA de l'item                             *
 *                                                                                     *
 ***************************************************************************************/
int 
pcp_affiche_frame (item,event)
Panel_item item;
Event *event;
{
  Frame framep = (Frame)  xv_get (item, PANEL_CLIENT_DATA);
  Rect  *rect  = (Rect *) xv_get (xv_get(glo.frame_principal,XV_ROOT), WIN_MOUSE_XY);  /* vol.7 p.286 */
  int   x      = rect->r_left - xv_get(framep, XV_WIDTH)/2;
  int   y      = rect->r_top  + 50;

  if (x < 10) x = 10;

  xv_set (framep, XV_X, x, XV_Y, y, XV_SHOW, TRUE, NULL); 

#ifdef DEBUG
  printf("pcp_affiche_frame %s\n",xv_get(framep,FRAME_LABEL));
#endif

  return XV_OK;
}

/***************************************************************************************
 * Affiche un message                                                                  *
 *                                                                                     *
 ***************************************************************************************/
void
pcp_avertissement (name1, name2, name3)
char *name1, *name2, *name3;
{
  Rect  *rect  = (Rect *) xv_get (xv_get(glo.panel1, CANVAS_NTH_PAINT_WINDOW,0), WIN_MOUSE_XY);
  int   x      = rect->r_left;
  int   y      = rect->r_top;
         
  pcp_avertis_xy (name1, name2, name3, x, y);
}

/***************************************************************************************
 * Affiche un message en x,y                                                           *
 *                                                                                     *
 ***************************************************************************************/
void
pcp_avertis_xy (name1, name2, name3, x, y)
char *name1, *name2, *name3;
int   x, y;
{      
  (void) notice_prompt(glo.panel1, NULL,
      NOTICE_FOCUS_XY,         x, y,
      NOTICE_MESSAGE_STRINGS,  name1, name2, name3, NULL,
      NOTICE_BUTTON_YES,       "OK",
      NOTICE_NO_BEEPING,       TRUE,
      NULL);
}

/***************************************************************************************
 * Affiche au centre d'un icone                                                        *
 *                                                                                     *
 ***************************************************************************************/
void
pcp_avertis_ico (name1, name2, name3, ico)
char *name1, *name2, *name3;
Ico   *ico;
{   
    pcp_avertis_xy (name1, name2, name3,
	(int) xv_get (glo.canvas, XV_X) + ico->xb + ico->xm/2,
	(int) xv_get (glo.canvas, XV_Y) + ico->yb + ico->ym/2  );
}

/***************************************************************************************
 * Affiche un message d'erreur interne en NOTICE                                       *
 *                                                                                     *
 ***************************************************************************************/
void pcp_error  (char *mot, ...)
{
  va_list    ap;
  char       *array[100];
  char       *texte = "FATAL ERROR\n";
  int        n = 0;
  Xv_Notice  notice;

  array[n++] = texte;
  array[n++] = mot;

  for ( va_start (ap, mot);
	mot != NULL;
	mot = array[n++] = va_arg (ap, char *)) ;
  va_end (ap);

  notice = xv_create (glo.frame_principal, NOTICE,
	NOTICE_MESSAGE_STRINGS_ARRAY_PTR,	array,
	XV_SHOW,				TRUE,
	NULL);

  xv_destroy_safe (notice);
}

/***************************************************************************************
 * Affiche un message dans le FRAME_LEFT_FOOTER                                        *
 *                                                                                     *
 ***************************************************************************************/
void pcp_footer  (char *mot, ...)
{
  va_list  ap;
  char     bla[256];

  bla[0] = 0;
  for ( va_start (ap, mot);
	mot != NULL;
	mot = va_arg (ap, char *))
    sprintf (bla, "%s%s", bla, mot);
  va_end (ap);
  xv_set (glo.frame_principal, FRAME_LEFT_FOOTER, bla, NULL);
}

void pcp_footer_n ()
{
  xv_set (glo.frame_principal, FRAME_LEFT_FOOTER, "", NULL);
}


/***************************************************************************************
 * Malloc avec comptage et test d'allocation
 *
 ***************************************************************************************/
void *pcp_alloc (size)
int   size;
{
  void *p;
  char bla[80];

  if ((p = (void *) malloc (size)) == NULL) {
      sprintf (bla, "pcp_alloc (%d)", size);
      pcp_error ("Malloc failed in", bla, NULL);
  }
  else {
      glo.nb_alloc++;
      sprintf (bla, "%d", glo.nb_alloc);
      xv_set (glo.frame_principal, FRAME_RIGHT_FOOTER, bla, NULL);
  }

  return p;
}

/***************************************************************************************
 * free avec comptage
 *
 ***************************************************************************************/
void  pcp_free (p)
void *p;
{
  char bla[80];

  if (p != NULL) {
      free (p);
      glo.nb_alloc--;
      sprintf (bla, "%d", glo.nb_alloc);
      xv_set (glo.frame_principal, FRAME_RIGHT_FOOTER, bla, NULL);
  }
}

/***************************************************************************************
 * calcule nb_sec.nb_micro_sec de l'instant
 *
 ***************************************************************************************/
void pcp_gettime (t)
double *t;
{
  struct timeval tp;

  if (gettimeofday (&tp, (struct timezone *) NULL) == 0)
       *t = (double) tp.tv_sec + (double) tp.tv_usec / (double) 1E6;
  else *t = 0;
}

/***************************************************************************************
 * Creation du bouton et du menu "Extra" du frame_principal
 *
 ***************************************************************************************/
Panel_item pcp_FramePcpButtCreat (panel)
Panel panel;
{
    Menu menu = (Menu) xv_create (NULL, MENU,
	MENU_STRINGS,		"Text window", "Reread menus", 
				"Edit .ipsrc", "Remote host", NULL,
	MENU_NOTIFY_PROC,	pcp_FramePcpMenuProc,
	NULL);

    return (Panel_item) xv_create (panel, PANEL_BUTTON,   
	PANEL_LABEL_STRING,	"Extra",
	PANEL_ITEM_MENU,	menu,
	NULL);
}

/***************************************************************************************
 * Gestionnaire du signal USR1 : on fait un [Reread Menus]
 *
 ***************************************************************************************/
Notify_value pcp_sigusr1_handler (client, sig, when)
Notify_client client;
int sig;
{
    static int lecture_en_cours = FALSE;

    /* printf("Received signal %d\n", sig); */

    if (!lecture_en_cours) {  /* Non reentrance */
	lecture_en_cours = TRUE;
	lmt_FramePcpButtReread ();
	lecture_en_cours = FALSE;
    } else printf ("Erreur : signal USR1 reu, prcdent pas fini\n");

    return NOTIFY_DONE;
}



/***************************************************************************************
 * Activation du choix dans le menu "Extra" du frame_principal
 *
 ***************************************************************************************/
void pcp_FramePcpMenuProc (menu, menu_item)
Menu menu;
Menu_item menu_item;
{
    char *menu_str = (char *) xv_get (menu_item, MENU_STRING);

    if (!strcmp(menu_str, "Text window")) {

	aide_reaffi ();
    }
    else if (!strcmp(menu_str, "Reread menus")) {

	(void) lmt_FramePcpButtReread ();
    }
    else if (!strcmp(menu_str, "Edit .ipsrc")) {

	char nomf[256];
	sprintf (nomf, "%s/.ipsrc", glo.home_dir);
	aide_affi_edit ("Edit .ipsrc", nomf, 0);
    }
    else if (!strcmp(menu_str, "Remote host")) {

	ho_affi_frame ();
    }
}

/***************************************************************************************
 * Affichage fenetre About
 *
 ***************************************************************************************/
void pcp_about ()
{
    Rect  *rect = (Rect *) xv_get (xv_get(glo.panel1, 
		CANVAS_NTH_PAINT_WINDOW,0), WIN_MOUSE_XY);

    (void) notice_prompt(glo.panel1, NULL,
	NOTICE_FOCUS_XY, rect->r_left, rect->r_top,
	NOTICE_BUTTON_YES, "OK",
	NOTICE_NO_BEEPING, TRUE,
	NOTICE_MESSAGE_STRINGS, 
	    "IPS - Image Processing Software", 
	    "",
	    "by Edouard Thiel", 
	    "(Edouard.Thiel@lim.univ-mrs.fr)", 
	    "", 
	    "Copyright "DATE_COPYRIGHT" by Edouard Thiel - All Rights Reserved", 
	    "Version "NUMERO_VERSION"      Last Revision: "DATE_RELEASE, 
	NULL, NULL);
}
