/***************************************************************************************/
/* ressource.c                                                I.P.S  v 3.1  18/11/1993 */
/*                                                                                     */
/* Lecture des ressources                                Edouard.Thiel@lim.univ-mrs.fr */
/***************************************************************************************/

#include "inclus.h"


#define LG_LIGNE	127+1
#define LG_MOTCLE	10+1
#define LG_OPER		127+1


/***************************************************************************************
 *
 *
 ***************************************************************************************/
Menu  res_lecture_mnu (chemin, name, frame, notify_proc)
char *chemin, *name;
Frame frame;
void  (*notify_proc)();
{
  char       nomf[LG_LIGNE], ligne[LG_LIGNE], mot[LG_MOTCLE], s1[LG_OPER], 
             *sm, *s_menu[1000], *suite, *idf[LG_OPER];
  FILE      *f;
  int        n_ligne, n_menu, n_subm, motp, erreur;
  Menu       menu[1000];
  Menu_item  mi;

  /* Ouverture du fichier */
  sprintf (nomf, "%s%s", chemin, name);
  if ((f = fopen (nomf, "r")) == NULL) return NULL;

  /* Initialisations */
  menu[0] = NULL;
  n_menu  = n_ligne = 0;
  erreur  = FAUX;

  /* Lecture du fichier */
  while ( fgets(ligne , LG_LIGNE , f ) != NULL )
  {
    n_ligne++;

    if ( sscanf (ligne, "%s%n", mot, &motp) == EOF || mot[0] == ';' || mot[0] == '*' )
      continue; /* on saute la ligne */

    suite = ligne + motp;

    if (!strcmp (mot, "MENU"))
    {
      sscanf (suite, "%d \"%[^\"]\"", &n_menu , s1);

      sm = s_menu[n_menu] = stg_Cpy (s1);

      menu[n_menu] = (Menu) xv_create (NULL, MENU,
	MENU_TITLE_ITEM,		sm,
	MENU_GEN_PIN_WINDOW,	frame,	sm,
	MENU_NOTIFY_PROC,	notify_proc,
	NULL);
    }

    else if (mot[0]=='O' && mot[1]=='P' && mot[2]=='E' && mot[3]=='R')
    {
      sscanf (suite, "%s \"%[^\"]\"", idf, s1);

      sm = stg_Cpy (s1);

      mi = (Menu_item) xv_create (NULL, MENUITEM,
	MENU_STRING,		sm,
	MENU_CLIENT_DATA,	stg_Cpy (idf),
	MENU_RELEASE,
	MENU_INACTIVE,		mot[4] != 0,
	NULL);
      xv_set (menu[n_menu], MENU_APPEND_ITEM, mi, NULL);
    }

    else if (mot[0]=='S' && mot[1]=='U' && mot[2]=='B' && mot[3]=='M')
    {
      sscanf (suite, "%d", &n_subm);

      mi = (Menu_item) xv_create (NULL, MENUITEM,
	MENU_STRING,		s_menu[n_subm],
	MENU_PULLRIGHT,		menu[n_subm],
	MENU_RELEASE,
	MENU_INACTIVE,		mot[4] != 0,
	NULL);
      xv_set (menu[n_menu], MENU_APPEND_ITEM, mi, NULL);
    }

    else if (!strcmp (mot, "ENDM"))
    {
      n_menu = 0;
    }

    else erreur = VRAI;

    if (erreur)
    {
      char bla[200];
      sprintf(bla, "line %d word \"%s\"\n", n_ligne, mot);
      pcp_error ("res_lecture_mnu #02", "Syntax error in file", name, bla, NULL);
      break;
    }
  }
 
  /* Fermeture */
  fclose (f);
  return (menu[0]);
}


