/***************************************************************************************/
/* tel_protoc.h                                              I.P.S  v 3.6a  03/11/1995 */
/*                                                                                     */
/* Module du protocole IPS_SOCKET                                Edouard.Thiel@lim.univ-mrs.fr */
/***************************************************************************************/

#define TP_NUM_PROTOCOL "1.0"


/* -------------------------- DESCRIPTION DU PROTOCOLE ----------------------------------

IPS_SOCKET est le protocole utilise' par IPS pour e'changer des images, des boites de 
parame`tres, etc, entre IPS et les tel_oper (bibliothe`ques exe'cutables d'ope'rateurs).  

Le protocole IPS_SOCKET s'appuie sur la couche protocole UDP/IP, c'est a` dire sur le 
mode DATAGRAM dans le domaine INTERNET. Il s'agit d'un mode NON CONNECTE', qui permet
l'envoi de messages borne's (< 2k) de facon tres efficace.

Un message IPS_SOCKET est compose' d'un ente^te (32 octets) puis d'une commande, 
e'ventuellement suivie de parame^tres ou d'un bloc de donne'es.

Lorsqu'un message est envoye', il n'est pas possible de savoir directement si le
correspondant a bien recu le message. Alors est mis en place un mecanisme d'acquitement
avec timeout au niveau du tel_oper.
Conside'rons l'instant ou tel_oper a envoye' son message ; il met en marche le timeout
(2 sec.). Si dans cet intervalle tel_oper recoit une reponse, tout va bien et on passe
au message suivant.
Si le timeout est atteint, cela veut dire que IPS n'a pas recu le message, ou que IPS
etait occupe' et ne l'a pas encore traite', ou que la re'ponse d'IPS n'est pas arrive'e.
Alors tel_oper re'envoie le message (qu'il avait stocke') a IPS, et attend la re'ponse
d'IPS avec un nouveau timeout.
Du co^te' d'IPS : si une re'ponse avait de'ja e'te' e'mise, elle a e'te' stocke'e, et on
renvoie une copie de la re'ponse (sans traiter le message).
Les messages sont numerote's dans l'ente^te, et un filtre interdit le dedoublement des
dialogues. Ces quelques re`gles rendent le protocole totalement fiable.

Les commandes de base sont < 100.
Le chiffre de centaine est le numero de section.
Les commandes de section avancent par +3, ou +5 quand il y a un passage de blocs.

Commandes :
	IMPAIRES   tel_oper --> IPS 
PAIRES		   tel_oper <-- IPS

-----------------------------------------------------------------------------------------
Schema general :


	 11	HELO	Identification : pid et protocole
 14		SHORT	Option : test de representation locale d'un Unsigned Short
	 17	REQTE	Demande la requete 


 22		WAIT	Mettre le timeout = 12 sec pour quitter
 24		DODO	Idem a WAIT avec timeout long


	 31	CIAO	Demande l'ordre QUIT
 34		QUIT	Ordre de quitter immediatement.
	 37	BYE	Avis de suicide ; pas de retour.

-----------------------------------------------------------------------------------------
Envoi par t_o ou IPS d'un buffer par blocs ; l'appelant stocke ord_suiv


	 49	REP	Donne infos sur buffer
 52		SEND	Demande l'envoi du bloc num_bloc
	 55	BLOC	Envoie un bloc du buffer
 58		DONE	Tout est recu, et ordre = ord_suiv


 60		REP	Donne infos sur buffer
	 63	SEND	Demande l'envoi du bloc num_bloc
 66		BLOC	Envoie un bloc du buffer
	 69	DONE	Tout est recu, et ordre = ord_suiv

-----------------------------------------------------------------------------------------
Section DEF :


 100		ACT	Donne l'action IPS_ACT_DEF a faire sur idf
    49:58
	 105	GO	Tout est envoye', on peut construire la parbox.
 22		WAIT	

-----------------------------------------------------------------------------------------
Section CHOICE :


 200		ACT	Donne l'action IPS_ACT_CHOICE a faire sur idf
 	203	ENCO	Demande d'encoder les parametres
    60:69
 208		GO	Ordre : de'code params, appelle section CHOICE, re'encode params
    49:58
 	213	MAJ	Tout est envoye', on peut mettre a jour la parbox.
 22		WAIT	
	
-----------------------------------------------------------------------------------------
Section DIM-EXE :


 300		ACT	cf 200 : Donne l'action IPS_ACT_DIM a faire sur idf
	 303	ENCO	cf 203 : Demande d'encoder les parametres
    60:69
 308		DECO	Ordre : de'code params
	 311	ENCO	Demande d'encoder les infos des images
    60:69
 316		GO	Ordre : de'code les infos, appelle section CO_DIM, re'encode
    49:58
	 321	DECO	Ordre : de'code les infos, m-a-j images
  24		DODO	En attendant d'avoir termine m-a-j images

 324		FOR	Dit de demander datas (image) ; repond ASK ou READY
	 327	ASK	Demande une data (image)
 330		REP	Infos buffer et creation buffer data (image)
    63:69
 336		NEXT	Faire le ASK suivant, ou READY
	 339	READY	Mettre le footer a "Running" et appeler GO
 342		GO	Appel de la section EXE

	 399	SPY	Option : t_o indique a IPS le % de l'execution re'alise'.

	 345	FOR	Dit de demander resultats (image) ; IPS repond ASK ou READY
 348		ASK	Demande une data (image)
	 351	REP	Infos buffer et preparation buffer data (image)
    52:58
	 357	NEXT	Dit de faire le ASK suivant, ou READY (+ footer "...done")
 360		READY	libere datas ; re'encode params
    49:58
	 365	MAJ	Dit que tout est envoye', on peut mettre a jour la parbox.
 368		STAT	Demande de stat. sur l'execution
	 371	INFO	Infos sur l'execution pour footer et refresh des icones
 22		WAIT	

-----------------------------------------------------------------------------------------
Section FIG :

 
400		ACT	Donne le idf
 	403	ENCO	Demande d'encoder les parametres
    60:69
408		DECO	Ordre : de'code params
        411	EVT	Demande d'envoyer une collection d'evenements
414		GO	Traite evenements, appelle section FIG ; envoi dessins
    49:58
 	419	DRAW	Dessins recus, fait dessins, va en 422 ou 424 si evts stockes
422		NEXT	Enchaine avec GO:414, sans malloc pour datas dessins
424		READY	reencode params, libere params et libere datas dessins
    49:58
	429	MAJ	Met a jour parbox, puis Working=0 et DODO, ou recommence 400.
24		DODO

--------------------------------------------------------------------------------------- */


