/***************************************************************************************/
/* edi_princ.h                                                I.P.S  v 3.1   18/3/1994 */
/*                                                                                     */
/* Editeur graphique                                     Edouard.Thiel@lim.univ-mrs.fr */
/***************************************************************************************/

#define EDI_ICO_IMAGE			43101
#define EDI_ICO_2IMAGES			43102
#define EDI_ICO_CLIENTS			43103
#define EDI_TOOLS			43104
#define EDI_VAL_A			43105
#define EDI_VAL_B			43106
#define EDI_ACT_A			43107
#define EDI_ACT_B			43108
#define EDI_EVENT_PROC			43109
#define EDI_REPAINT_PROC		43110
#define EDI_RESIZE_PROC			43111
#define EDI_DONE_PROC			43112
#define EDI_CLIENT_DATA			43113
#define EDI_NAME			43114
#define EDI_DEAD_REFRESH		43115

#define EDI_DONE_BY_MOUSE		43151
#define EDI_DONE_BY_MESSA		43152

#define EDI_CLE_UTILISATION		129384756

#define EDI_ACT_NULL	0
#define EDI_ACT_ENFONCE	1
#define EDI_ACT_RELACHE	2
#define EDI_ACT_TIRE	3
#define EDI_ACT_ANNULE	4
#define EDI_ACT_DEPLA	5
#define EDI_ACT_SORTIE	6

#define EDI_MOUSE_A	1
#define EDI_MOUSE_B	2

#define EDI_GET_VAL_A(edi)	(edi->panel_val_a == 0) ? 0 : \
				(int) xv_get (edi->panel_val_a, PANEL_VALUE)
#define EDI_GET_VAL_B(edi)	(edi->panel_val_b == 0) ? 0 : \
				(int) xv_get (edi->panel_val_b, PANEL_VALUE)

#define EDI_SET_VAL_A(edi,x)	if (edi->panel_val_a != 0) \
				xv_set (edi->panel_val_a, PANEL_VALUE, x, NULL)
#define EDI_SET_VAL_B(edi,x)	if (edi->panel_val_b != 0) \
				xv_set (edi->panel_val_b, PANEL_VALUE, x, NULL)


/*
 * Type info pour le repere de l'editeur
*/

typedef struct st_rep { 
	int		xm, ym,
			zoom, step,
			bx, by,
			xmin, xmax, ymin, ymax;
	char		show;
	Frame		frame;
	Canvas		canvas;

	Display		*dpy;			/* Parametres pour l'affichage en X11	*/
	Visual		*visual;		/* dans le Canvas edi->rep.canvas	*/
	Xv_Window	p_win;
	Window		xwin;
	int		screen,
			depth;
	GC		gc;
	} Rep;


/*
 * Type info pour l'editeur
*/

typedef struct st_edi {

	/* DONNEES EXPLOITABLES PAR LE CLIENT */

	Ico		*ico1, *ico2;
	Unt16		*tab1,			/* pixmap edite				*/
			*tab2;			/* second pixmap pour la loupe		*/
	int		cmin1, cmin2,		/* */
			xtot1, xtot2,		/* */
			xsiz1, xsiz2,		/* */
			ysiz1, ysiz2,		/* */
			bxmin, bymin,		/* borne min sur tab1			*/
			bxmax, bymax,		/* borne max sur tab1			*/
			bxdif, bydif,		/* bxdif = bxmax - bxmin		*/
			cxdif, cydif,		/* taille du canvas width, height	*/
			exdif, eydif,		/* taille du canvas a l'ecran		*/
 			sx, sy,			/* coordonnees de la souris		*/
			sb,			/* bouton souris : EDI_MOUSE_A, _B	*/
 			x1, x2, y1, y2,		/* ancien point et nouveau point	*/
        		zoom,                   /* facteur de grossissement		*/
			loupe,			/* 0=normal , 1=loupe1 , 2=loupe2	*/
			act_a, act_b,		/* 0, 1, 2, .. pour chaque EDI_ACT_  	*/
			act_a_move, act_b_move, /* valeur signifiant move		*/
			act_cur,		/* = act_a ou act_b / bouton souris sb	*/
			val_cur;		/* valeur courante  / bouton souris sb	*/
	Unt32		*coul_tab1, *coul_tab2;	/* tables de couleurs active		*/

	int		(*client_tools_proc)(),		/* Fonctions du client		*/
			(*client_event_proc)();
	void		(*client_repaint_proc)(),
			(*client_resize_proc)(),
			(*client_done_proc)(),
			*client_data[16];	/* pour attacher des donnees perso	*/

	Display		*dpy;			/* Parametres pour l'affichage en X11	*/
	Visual		*visual;		/*   dans la fenetre d'edition.		*/
	Xv_Window	p_win;
	Window		xwin;
	int		screen,
			depth;
	GC		gc;

	/* DONNEES PRIVEES, INTERDITES AU CLIENT */

	Frame		frame;
	Canvas		canvas;
	Menu		menu_vision,
			menu_size,
			menu_outil;
	Panel_item	panel_act_a,
			panel_act_b,
			panel_slider_zoom,
			panel_val_a,
			panel_val_b;
	Rep		rep;
	int		messa_index,
			dedans,
			dead_refresh,
			cle_utilisation;
	} Edi;



/*
 * Fonctions
*/

extern void  edi_init_generale		();
extern Edi  *edi_create_win (int ordre, ...);
extern void  edi_done_proc		();	/* appele' par le window manager	*/
extern void  edi_tuer_edi		();	/* supprimer edi et la fenetre		*/
extern void  edi_dessin_point		();	/* dessin pt zoom*zoom ou en mode loupe	*/
extern void  edi_loupe_init		();	/* init des caracteres de la loupe	*/
extern void  edi_loupe_quadri		();	/* dessin du quadrillage de la loupe	*/
extern void  edi_loupe_case		();	/* dessin d'une case de la loupe	*/
extern void  edi_loupe_label		();	/* Affi chiffre en police "loupe"	*/
extern void  edi_vecteur_ecran		(); 	/* mettre image en vecteur pour affi	*/
extern void  edi_vecteur_ecran_RRG	(); 	/* idem en RGB                         	*/
extern void  edi_repaint		();	/* afficher l'image automatiquement	*/
extern void  edi_repaint_direct		();	/* appel direct de edi_repaint		*/
extern void  edi_resize			();	/* changer la taille d'une fen editeur	*/
extern void  edi_calc_edi		();	/* recalcul de EDI_T *edi		*/
extern void  edi_reborne		();	/* reborne txmin, txmax, tymin, tymax	*/
extern void  edi_choix_vision		();	/* choix : loupe, repere		*/
extern void  edi_choix_taille		();	/* choix : taille de la fenetre		*/
extern void  edi_slider_zoom_proc	();	/* Choix du Zoom sur l'image		*/
extern int   edi_choix_act		();	/* mise a jour act_a et act_b		*/
extern void  edi_choix_tools		();	/* appelle la tools_proc du client	*/
extern void  edi_event_proc		();	/* traitement d'un evenement souris	*/

extern void  edi_menu_pane_init		();
extern void  edi_menu_contextuel	();
extern void  edi_menu_pane_proc		();

extern void rep_init			();	/* init de rep				*/
extern void rep_cacher_frame		();	/* cacher la fenetre rep		*/
extern void rep_repaint			();	/* afficher				*/
extern void rep_repaint_direct		();	/* appel direct de edi_repaint		*/
extern void rep_calc_cadre		();	/* recalcul des coord du cadre dans rep	*/
extern void rep_rect_relief		();	/* dessine un rect pour effet de relief	*/
extern void rep_affi_cadre		();	/* affiche le cadre			*/
extern void rep_event_proc		();	/* traitement d'un evenement souris	*/

extern void edi_maj_par1		();
extern void edi_maj_par2		();
extern void edi_maj_nom			();
extern void edi_messaProc		();

extern void edi_undo_now		();
extern int  edi_undo_save		();


